#version 430

#pragma include "common.glsl"

uniform mat4 p3d_ModelViewMatrix;
uniform mat4 p3d_ProjectionMatrix;

const float scale = 0.3;

out vec2 coord;
out vec3 color;

void main() {
  int emberid = gl_VertexID / 3;
  int vtxid = gl_VertexID % 3;

  vec4 pos = p3d_ModelViewMatrix * vec4(embers[emberid].pos, 1);
  float size = embers[emberid].size * scale;
  if (vtxid == 0) {
    pos.y -= 0.15 * size;
    coord = vec2(0.5, 0);
  } else if (vtxid == 1) {
    pos.x -= 0.15 * size;
    coord = vec2(-0.5, 1);
  } else if (vtxid == 2) {
    pos.x += 0.15 * size;
    coord = vec2(1.5, 1);
  }

  float dimming = 1-size;
  color = vec3(1, dimming, dimming) * dimming * dimming * 1.3;

  gl_Position = p3d_ProjectionMatrix * pos;
}
